// NO2light.cc  8-9-2001 

#include<iostream.h>
#include<fstream.h>
#include<stdio.h>
#include<ctype.h>
#include<string.h>
#include"utils.h"
#include"tset.h"
#include"appl.h"

static int num_attr = NATTR;     
// name of the NEURObjects data set 
static char NOdata[128]; 
// base name of the SVM-light data set 
static char lightdata[128]; 
// name of the file to be used to determine st. dev and mean for  normalization 
static char datamain[128]; 
// flag showing if datamain is used; 0 = no used, 1 = used 
static int datamainused = 0;
// separator char of the NEURObjects data set 
static char sepin = SEPIN;
// normalization data set flag
static int is_normalized = 0;


static void print_info_use(void);
static int doarg(char* arg[], int i);

int main (int argc, char * argv[])
{
  int i;
	unsigned num_train;
	
	
	if (argc < 3)
	  print_info_use();
	
	strcpy(NOdata,argv[1]);
	strcpy(lightdata,argv[2]);
	for (i=3; i<argc; i+=2)
     if (doarg(argv, i))
        print_info_use();	
	
	num_train = wc (NOdata);  
  TrainingSet trainset(num_attr, num_train,  NOdata, sepin);
	if (is_normalized) {
	   if (datamainused)  {  // datamain used: so the traiset uses its mean and stdev for normalization)
		   num_train = wc (datamain);
		   TrainingSet maindataset(num_attr, num_train,  datamain, sepin);
			 maindataset.normalize();
			 trainset.normalize(maindataset.Read_mean(), maindataset.Read_stdev());
		 }
		 else
	     trainset.normalize();
	}
	
	trainset.save_light_format(lightdata); 
		
  return 0;
}


static int doarg(char* arg[], int i)
{
  int j;
	if (!strcmp(arg[i], "-d")) {
    num_attr = atoi(arg[i+1]);
		if (num_attr < 1) error_exit("Number of attributes must be 1 or more");}
	else if (!strcmp(arg[i], "-sepin")) {
    sepin = arg[i+1][0];
		if (!isprint(sepin)) error_exit("Separator must be a printable character");}
	else if (!strcmp(arg[i], "-n")) {
    is_normalized = atoi(arg[i+1]);
		if ((is_normalized != 0) && (is_normalized != 1)) error_exit("-n option must be 0 or 1");}
	else if (!strcmp(arg[i], "-u")) {
	  datamainused = 1;
    strcpy (datamain, arg[i+1]);}
  else 
    return 1;
  return 0;
} 


void print_info_use(void)
{
  cerr << "
  NO2light. NEURObjects application to convert NEUROBject data file into SVM-light format
  Usage: NO2light NOdata lightdata [options]
  Options:
  -d  unsigned      sample dimension
  -sepin char       separator of the NEURObjects dataset
  -n  {0,1}         if n=1 data are normalized
  -u string         file to be used to determine normalization parameters
  " << endl;
  exit(1);
}
