// SNR_feature_rank.cc  3-9-2002 

#include<iostream.h>
#include<fstream.h>
#include<ctype.h>
#include<stdlib.h>
#include"utils.h"
#include"tset.h"
#include"matrix.h"
#include"snr.h"

static void print_info_use(void);

int main (int argc, char * argv[])
{
  int i;
	unsigned num_patt, num_attr, cl, n;
	char dataset[128]; 
	char feature[128]; 
  float significance;

	
	if (argc != 7)
	  print_info_use();
	
	strcpy(dataset,argv[1]);
	strcpy(feature,argv[2]);
	n = atoi(argv[3]);
	cl = atoi(argv[4]);
	num_attr = atoi(argv[5]);
	num_patt = atoi(argv[6]);

  
	
	SNRTest snr(num_attr, num_patt, dataset);
	
	snr.SNR_compute(cl);	
	//snr.SNR_print(cout); 
  snr.rank_features();
	//snr.print_ranked_feature_indices(n, cout);
	snr.save_ranked_feature_indices(n, feature);
  
  return 0;
}



void print_info_use(void)
{
  cerr << "
  SNR_feature_sel. NEURObjects application to select the n features with the largest SNR correlation measure
  Usage: SNR_feature_rank dataset f_file n cl nattr npatt 
  dataset   source file 
  f_file    file where the selected feature indices will be stored
  n         number of the first features to be selected
  cl        number of the class
  nattr     is the number of the attributes
  npatt     is the number of the patterns  
  " << endl;
  exit(1);
}
