// "act_fun.cc"

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include "act_fun.h"

#define LTAB_LENGTH 1000
#define LTAB_MAX    10.0

static double f_factor, f_s[1000 ], f_sd[1000 ] ;
static double f_t[1000 ], f_td[1000 ] ;
static double beta = DEFAULT_BETA;   
static double ggamma = DEFAULT_GAMMA;   

void sigmoid_init (double coeff) 
{
   int i ;
	 static int is_set = 0;
	 if (is_set)
	   return ;
	 else is_set = 1;
	 
   beta = coeff;
   f_factor = (double) (1000  - 1) / (double) 10.0  ;
   for (i=0 ; i< 1000  ; i++) {
      f_s[i] = 1.0 / (1.0 + exp ( - beta*((double) i) / f_factor )) ;
      if (i)
         f_sd[i-1] = f_s[i] - f_s[i-1] ;
      }
}
double sigmoid ( double x )
{
   int i ;
   double xd ;
   if (x >= 0.0) {                    
      xd = x * f_factor ;             
      i = (int) xd ;                  
      if (i >= (1000  - 1))     
         return f_s[1000 -1] ;  
      return f_s[i] + f_sd[i] * (xd - i) ;  
      }
   else {                             
      xd = -x * f_factor ;
      i = (int) xd ;
      if (i >= (1000  - 1))
         return 1.0 - f_s[1000 -1] ;
      return 1.0 - (f_s[i] + f_sd[i] * (xd - i)) ;
      }
}
double d_sigmoid ( double f )
{
   return (beta * f * (1.0 - f)) ;    
}
double inverse_sigmoid ( double f )
{
   return -log ( 1.0 / f - 1.0 ) ;  
}
void tanhyp_init (double coeff)
{
   int i ;
	 static int is_set = 0;
	 if (is_set)
	   return ;
	 else is_set = 1;
	 
   ggamma = coeff;
   f_factor = (double) (1000  - 1) / (double) 10.0  ;
   for (i=0 ; i< 1000  ; i++) {
      f_t[i] = tanh(ggamma * (((double)i)/ f_factor));
      if (i)
         f_td[i-1] = f_t[i] - f_t[i-1] ;
      }
}
double tanhyp ( double x )
{
   int i ;
   double xd ;
   if (x >= 0.0) {                    
      xd = x * f_factor ;             
      i = (int) xd ;                  
      if (i >= (1000  - 1))     
         return f_t[1000 -1] ;  
      return f_t[i] + f_td[i] * (xd - i) ;  
      }
   else {                             
      xd = -x * f_factor ;
      i = (int) xd ;
      if (i >= (1000  - 1))
         return - f_t[1000 -1] ;
      return - (f_t[i] + f_td[i] * (xd - i)) ;
      }
}
double d_tanhyp ( double f )
{
   return (ggamma * (1 - f * f));
}
double NO_identity (double x) {return x;}
double NO_d_identity (double x) {return 1.0;}
