#ifndef ACT_FUN_H
#define ACT_FUN_H

#define DEFAULT_BETA     1.0
#define DEFAULT_GAMMA    0.4

typedef double (*act_func)(double arg);

/// Initialization of sigmoid function
void sigmoid_init (double coeff=DEFAULT_BETA);
/// Output of sigmoid on input x
double sigmoid ( double x );
/// Output of sigmoid derivative on input x
double d_sigmoid ( double f );
/// Output of the inverse of sigmoid on input x
double inverse_sigmoid ( double f );

/// Initialization of hyperbolic tangent function
void tanhyp_init (double coeff = DEFAULT_GAMMA);
/// Output of hyperbolic tangent function on input x
double tanhyp (double x);
/// Output of hyperbolic tangent derivative on input x
double d_tanhyp ( double f );

/// Output of linear activation function on input x 
double NO_identity (double x); 
/// Output of linear activation derivative on input x 
double NO_d_identity (double x);




#endif
