// "appl.cc"

#include "appl.h"

const unsigned NCLASS = 2;  
const unsigned NFOLD = 10;  
const unsigned NATTR = 2;    
const unsigned NLAYERS = 2;  
const unsigned NHIDDEN1 = 6;  
const unsigned NHIDDEN2 = 4;  
const unsigned MAXITS = 1000;   
const double ERRTOL = 0.1;  
const unsigned LEARNTYPE = GRADIENT_DESCENT;   
const unsigned LEARNMODE = BYPATT;   
const double ETA = 0.07;   
const double ALPHA = 0.5;   
const double INCR = 1.02;   
const double DECR = 0.4;   
const double DECRMOM = 0.998;   
const unsigned NUMTYPE = 2;
const char* SUBBASENAME = "t"; 
const  unsigned NSAMPLES = 100;
const unsigned NDATASETS = 1;
const char SEPIN = ',';
const char SEPOUT = ',';


char* typenet[]  = {"normal",
                    "ecoc"};
const unsigned NUMMODE = 2;
char* modecode[] =  {"bypat",
                     "byep"};
const unsigned NUMALG = 8;
char* algcode[] =  {"gd",
                  	"gd_dl",
                  	"gd_de",
                  	"md",
                  	"md_dl",
                  	"md_de",
                  	"bold",
                  	"boldmom"};
const unsigned NUMDEC = 6;
char* deccode[] =  {"OPC",
                  	"PWC",
                  	"CC",
                  	"ECOC_ex",
										"ECOC_BCH",
										"DEC_FILE"};
                  	
int Analyze_type(char* type)
{
  unsigned i=0;
  while ((i<NUMTYPE) && (strcmp(type, typenet[i]))) i++;
  return i;
}                   	
int Analyze_mode(char* m)
{
  unsigned i=0;
  while ((i<NUMMODE) && (strcmp(m, modecode[i]))) i++;
  return i;
} 
int Analyze_alg(char* alg)
{
  unsigned i=0;
  while ((i<NUMALG) && (strcmp(alg, algcode[i]))) i++;
  return i;
} 
int Analyze_dec(char* scomp)
{
  unsigned i=0;
  while ((i<NUMDEC) && (strcmp(scomp, deccode[i]))) i++;
  return i;
} 
unsigned DoDefaultcw(unsigned const nclass)
{
  unsigned i, len;
	
	i=0;
	while (nclass >= pow(2,i)) i++;
	len = (unsigned)(pow(2,i)-2);
	if (len <= nclass)
	  len = (unsigned)(pow(2,i+1)-2); 
  return len;
}
