/* ******************************************************************************
NEURObjects 2.0
basemlp.cc January 2002
Giorgio Valentini
****************************************************************************** */

#include<iostream>
#include<strstream>
#include<cstdlib>
#include<string.h>
#include"baselearner.h"
#include"basemlp.h"
#include"utils.h"
#include<algorithm>


// BaseMLP_OneLayer ---------------------------------------------------------

/// Dummy constructor
BaseMLP_OneLayer::BaseMLP_OneLayer() : OneLayer() {
   num = 0;
	 seed = 0;  
   max_iterations = MAXITS;
   RMS_threshold = ERR_TOL;
   learn = NULL;
	 //copy(predicted_classes.begin(), predicted_classes.end(), ostream_iterator<unsigned>(cout, " "));
}

/* Constructor. */
BaseMLP_OneLayer::BaseMLP_OneLayer (unsigned nout, unsigned nin, Learning* learn_alg, 
                  double errtol, unsigned maxits, unsigned n, char sep, int s)  
                 : OneLayer(nout, nin) {
	 seed = s;
	 num = n; 
	 separator = sep;  
   max_iterations = maxits;
   RMS_threshold = errtol;
   learn = learn_alg;
	 
}






/**
	 Trains the base learner using a training set stored in a file.\\
	 The base learner is trained using the data set trainfile. The learned model is stored in the
	 file model. The file formats are in  NEURObjects file format. The data are not normalized and the mean and the
	 stdev of the data are stored for the testing.
	 @param trainfile  name of the training set
	 @param model  model file name.
	 @return error rate
*/
float BaseMLP_OneLayer::train_learner (char* trainfile, char* model){

  unsigned iter = 0;
	double error = 0;
	
	int num_train = wc (trainfile);   
	TrainingSet tset( Ninput(), num_train,  trainfile, separator, TrainingSet::last);
	
	//tset.calc_mean_stdev();
	
	
	tset.normalize();
	// saves the mean and stdev for the test
	mean = tset.Read_mean();
  stdev = tset.Read_stdev();
	init_weights_norm(seed);
	Learn_by_pattern(tset, *learn, iter, error, RMS_threshold, max_iterations, false);
	save_weights(model);
	matrix m  = test(tset);
	print_conf_matrix(m, cout);
	return (float)get_perc_errors();
}




/*Tests the base learner using a testing set stored in a file. */
float BaseMLP_OneLayer::test_learner(char* testfile, char* model, char* predicted){

  int num_train = wc (testfile);   
	TrainingSet tset( Ninput(), num_train,  testfile, separator, TrainingSet::last);
  tset.normalize(mean,stdev);
	read_weights(model);
	test(tset,predicted_classes);
  save_predicted(predicted_classes, predicted);
	return (float)get_perc_errors();
}






















