//binom.cc
// Usage : binom n kstart kend probability

#include<iostream>
#include<fstream>
#include<cstdlib>
#include"binomial.h"

#define WIDTH 15



using namespace std;



int main (int argc, char *argv[]) {
 
 double p,n,kstart,kend,res;
 char buf[256];
 
 if (argc != 3) {
	 cerr << "Usage : binom file n" << endl;
	 exit(1);
 }
 
 n = atoi(argv[2]);
 ifstream f(argv[1]);
 
 f.getline(buf,256);
 cout << buf << endl;
 f.getline(buf,256);
 
 cout.setf(ios::left,ios::adjustfield);
 cout.precision(8);
 cout.width(WIDTH); cout.setf(ios::left,ios::adjustfield); cout << "MHD";
 cout.width(WIDTH); cout.setf(ios::left,ios::adjustfield); cout << "Prob. error";
 cout.width(WIDTH); cout.setf(ios::left,ios::adjustfield); cout << "L1err";
 cout.width(WIDTH); cout.setf(ios::left,ios::adjustfield); cout << "Predicted error";
 cout << endl;
 
 unsigned MHD;
 double L1err, binomial_err;
 
 
 while (!f.eof()) {
   f >> MHD;   
	 f >> L1err;
	 f >> buf;
	 f >> p;
	 f>> buf;
	 kstart = (int)((MHD-1)/2)+1;
	 kend = n;
   binomial_err = Binomial::cumulative (n, kstart, kend, p);
		
	 cout.width(WIDTH); cout.setf(ios::left,ios::adjustfield); cout << MHD;
	 cout.width(WIDTH); cout.setf(ios::fixed,ios::floatfield); cout << p;
	 cout.width(WIDTH); cout.setf(ios::fixed,ios::floatfield); cout << L1err;
	 cout.width(WIDTH); cout.setf(ios::fixed,ios::floatfield); cout << binomial_err;
	 cout << endl; 
 }
 
 
 if (f.bad()) {
   cerr << "Error reading file " << argv[1] << endl;
	 exit(1);
 }
    
 

 return 0;
}
