// build_feature_subset_data.cc  3-9-2002 

#include<iostream.h>
#include<fstream.h>
#include<ctype.h>
#include<stdlib.h>
#include"utils.h"
#include"tset.h"
#include"matrix.h"
#include"snr.h"

static void print_info_use(void);

int main (int argc, char * argv[])
{
  int i;
	unsigned num_patt, num_attr;
	char dataset[128]; 
	char feature_data[128]; 
	char feature_indices[128]; 
	
	if (argc != 6)
	  print_info_use();
	
	strcpy(dataset,argv[1]);
	strcpy(feature_data,argv[2]);
	strcpy(feature_indices,argv[3]);
	num_attr = atoi(argv[4]);
	num_patt = atoi(argv[5]);
	
	
	SNRTest snr(num_attr, num_patt, dataset);
	snr.load_feature_indices(feature_indices);
	snr.save_selected_features(feature_data);
  return 0;
}



void print_info_use(void)
{
  cerr << "
  build_feature_subset_data. NEURObjects application to build a data set from selected features of a given dataset
  Usage: build_feature_subset_data source feature_data feature_indices nattr npatt
  source           source file from which the features have to be extracted
  feature_data     file where the selected features  will be stored
  feature_indices  file containing the indices of the features to be extracted from source
  nattr            is the number of the features of the source
  npatt            is the number of the patterns of the source
  " << endl;
  exit(1);
}
