// "build_net.cc"

#include<string.h>
#include"build_net.h"

static const unsigned DIMBUF = 256;   
static const unsigned DIMBUFNAMEFILE = 256;   
BuildNet::BuildNet(char* namefile, OneLayerTest** oln)
{
  (*oln) = build(namefile);
}
OneLayerTest* BuildNet::build(char* namefile)
{
  char namebuf[DIMBUFNAMEFILE];
  char buf[DIMBUF];
  unsigned nlayer, dimoutput, dimhidden1, dimhidden2, diminput;
  unsigned funout, funhid1, funhid2;
  unsigned bufint;
  act_func g_out, g_hid1, g_hid2;
  OneLayerTest* net;
  strcpy(namebuf, namefile);
  strcat(namebuf, NET_EXT);
  ifstream f(namebuf);
  if (!f) error("Cannot open file ", namebuf);
  f >> buf >> bufint;
  if (bufint != 1)
    error("File version .wgt not known.");
  f >> buf;
  if (strcmp(buf, namebuf))   
    error ("BuildNet::build :  file name not equal to the name of II row :", namebuf);
  f >> buf >> nlayer;
  switch (nlayer)  {    
    case 1: f >> buf >> dimoutput;
            f >> buf >> funout; 
            g_out = Decode_act_fun(funout);                       
            break;    
    case 2: f >> buf >> dimoutput;
            f >> buf >> funout; 
            g_out = Decode_act_fun(funout); 
            f >> buf >> dimhidden1;
            f >> buf >> funhid1;
            g_hid1 = Decode_act_fun(funhid1);
            break;     
    case 3: f >> buf >> dimoutput;
            f >> buf >> funout; 
            g_out = Decode_act_fun(funout); 
            f >> buf >> dimhidden1;
            f >> buf >> funhid1;
            g_hid1 = Decode_act_fun(funhid1);
            f >> buf >> dimhidden2;
            f >> buf >> funhid2;
            g_hid2 = Decode_act_fun(funhid2);
            break;
    default: error ("Numero strati non supportato."); break;
  }
  f >> buf >> diminput;
  if (f.bad())
    error("Error reading header file ", namebuf);
  switch (nlayer)  {   
    case 1: net = new OneLayerTest(dimoutput, diminput, g_out);                    
            break;    
    case 2: net = new TwoLayerTest(dimoutput, dimhidden1, diminput, g_out, g_hid1);
            break;     
    case 3: net = new ThreeLayerTest(dimoutput, dimhidden1, dimhidden2, diminput,
                                 g_out, g_hid1, g_hid2);
            break;
    default: error ("Not supported number of layers."); break;
  }
  net->read_weights(f); 
  eatwhite(f);  
  f >> buf;
  if (strcmp(buf, END))  
    error("End of file expected ", namebuf);
  if (f.bad())
    error("Error reading file ", namebuf);
  return net;
}  
act_func BuildNet::Decode_act_fun(unsigned fun)
{
  act_func g;
  switch (fun)  {
    case SIGMOID:
        g = sigmoid; break;  
    case TANHYP:
        g = tanhyp; break; 
    case IDENTITY:
        g = NO_identity; break; 
  default:
    error ("Not known activation function");
  }
  return g;
}
