#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"utils.h"


//float gammln(float xx);
//void gser(float *gamser, float a, float x, float *gln);
//void gcf(float *gammcf, float a, float x, float *gln);
//float gammp(float, float);
//float gammq(float, float);

/**
  Level of significativity Chi square test function. It returns the significativity level by 
	which the null hypothesis can be retained.
	@param pearson_stat value of the computed Pearson statistics
	@param degree degree of freedom for the chi square test.
	@return significativity level  by which the null hypothesis can be retained.
*/
float Prob_chi2(float pearson_stat, float degree);

/**
  Chi square test function. It returns if the null hypothesis can be discarded at significativity
	level sig_level.
	@param pearson_stat value of the computed Pearson statistics
	@param freedom_degree degree of freedom for the chi square test.
	@param sig_level significativity level  by which the null hypothesis can be discarded.
	@return 1 if the null hyphotesis can be discarded at significativity level sig_level, 0 otherwise.
*/
int Test_chi2(float pearson_stat, float freedom_degree, float sig_level);
