// convert_data_format.cc  9-9-2001 

#include<iostream.h>
#include<fstream.h>
#include<ctype.h>
#include"utils.h"
#include"tset.h"

static void print_info_use(void);

int main (int argc, char * argv[])
{
  int i;
	unsigned num_train, num_attr;
	char suffix[8];
	char dataset1[128]; 
	char dataset2[128]; 
  char sepin;
  char sepout;
	int is_normalized = 0;
  int res = 0;
  TrainingSet::class_pos pos = TrainingSet::last;

	
	if (argc < 6)
	  print_info_use();
	
	strcpy(dataset1,argv[1]);
	strcpy(dataset2,argv[2]);
	num_attr = atoi(argv[3]);
	sepin = argv[4][0];
	if (!isprint(sepin)) error_exit("Separator must be a printable character");
	sepout = argv[5][0];
	if (!isprint(sepout)) error_exit("Separator must be a printable character");
	if (argc >= 7) 
	  is_normalized = atoi(argv[6]);
  if (argc == 8) {
	  res = atoi(argv[7]);
  if (res==0)
      pos = TrainingSet::last;
  if (res==1)
      pos = TrainingSet::first;
  else
      pos = TrainingSet::noclass;
  
  }
     
		
	num_train = wc (dataset1); 
  TSetStrClass dataset(num_attr, num_train, dataset1, sepin, pos) ; 
	if (is_normalized)
	  dataset.normalize();
	// setting character separator
	dataset.set_sep(sepout);
	dataset.save(dataset2);
	
  return 0;
}



void print_info_use(void)
{
  cerr << "
  convert_data_format. NEURObjects application to convert data format
  Usage: convert_data_format dataset1 dataset2 nattr sep1 sep2 [norm] [pos]
  dataset1 is the dataset to be converted
  dataset2 is the converted data set
  nattr    is the number of the attributes
  sep1     is the separator character of  dataset1
  sep2     is the separator character of  dataset2
  norm     if = 1 normalization of data, = 0 no normalization (def.)
  pos      if = 0 (def.) the class is at the end of the line, if = 1 it is at the beginning, if = 2 no class label
  " << endl;
  exit(1);
}
