// "dofold.cc"


#include<stdlib.h>
#include<iostream.h>
#include"utils.h"
#include"tset.h"
#include"patgen.h"

static unsigned NFOLD = 10;  
static unsigned NATTR = 2;   
static const int DIMBUF = 128;
static char namefold[DIMBUF];  
static char namefile[DIMBUF];  
static unsigned num_fold = NFOLD;   
static unsigned num_attr = NATTR;   
static void print_info_use(void);
static int doarg(char* arg[], int i);
int main(int argc, char* argv[])
{
  int i;
  unsigned num_train;
  const char POINT = '.';
  if (argc < 2) print_info_use();
  strcpy(namefile, argv[1]);   
  extract(namefile, namefold, POINT);
  for (i=2; i<argc; i+=2)
    if (doarg(argv, i))
      print_info_use();
  num_train = wc (namefile); 
  TSetStrClass tset( num_attr, num_train, namefile);   
  tset.FoldRand(num_fold, namefold); 
  return 0;
}
static void print_info_use(void)
{
  cout << "
  dofold. NEURObjects application for  automatic construction
          of multiple folds of data.
  Usage: dofold  datafile [options]
  datafile (string) : data file that has to be subdivided in folds.
 Options:
 -nf unsigned      number of the folds (default = 10)
 -na unsigned      number of attributes  (default = 2)
 -name string      name of the fold  files (without suffix) 
                   If omitted datafile is used instead.
	" << endl;  
  exit(1);
}
int doarg(char* arg[], int i)
{
  if (!strcmp(arg[i], "-nf"))
    num_fold = atoi(arg[i+1]);
  else if (!strcmp(arg[i], "-na"))
    num_attr = atoi(arg[i+1]);
  else if (!strcmp(arg[i], "-name"))
    strcpy (namefold, arg[i+1]);
  else 
    return 1;
  return 0;
}  
