// filter_norm_data_oligo.cc  1-9-2002 

#include<iostream.h>
#include<fstream.h>
#include<ctype.h>
#include"utils.h"
#include"tset.h"
#include"matrix.h"

static void print_info_use(void);

int main (int argc, char * argv[])
{
  int i;
	unsigned num_train, num_attr;
	char suffix[8];
	char dataset1[128]; 
	char dataset2[128]; 
  float low_thresh, hi_tresh;
	int is_normalized = 0;

	
	if (argc < 6)
	  print_info_use();
	
	strcpy(dataset1,argv[1]);
	strcpy(dataset2,argv[2]);
	num_attr = atoi(argv[3]);
	low_thresh = atof(argv[4]);
  hi_tresh = atof(argv[5]);
	if (argc == 7) 
	  is_normalized = atoi(argv[6]);
		
	num_train = wc (dataset1);  
  TrainingSet trainset(num_attr, num_train,  dataset1);
  trainset.set_thresholds(low_thresh, hi_tresh);
	if (is_normalized)
	  trainset.normalize_var();
	trainset.save(dataset2);
	
  return 0;
}



void print_info_use(void)
{
  cerr << "
  filter_norm_data_oligo. NEURObjects application to filter and normalize oligonucleotide array data
  Usage: filter_norm_data_oligo dataset1 dataset2 nattr low_tresh hi_tresh [norm]
  dataset1   is the raw dataset 
  dataset2   is the normalized data set
  nattr      is the number of the attributes
  low_tresh  is the low threshold
  hi_tresh   is the ceiling
  norm     if = 1 normalization of data, = 0 no normalization (def.)
  " << endl;
  exit(1);
}
