// "learn.cc"


#include<time.h>
#include<math.h>
#include<iostream.h>
#include<fstream.h>
#include"learn.h"
#include"net.h"
#include"utils.h"

void GradientDescent::Update_delta_weights(unsigned n_layers, LayerNetTrain layer[] )
{
  int i; 
  for (i=0; i<n_layers; i++)  { 
    layer[i].DeltaW = -((layer[i].grad) * eta);
    layer[i].Delta_bias = -((layer[i].grad_bias) * eta); 
  }   
} 
void GradientDescent::Update_weigths(unsigned n_layers, LayerNetTrain layer[] )
{
  int j;
  for (j=0; j<n_layers; j++)  {                                                              
    layer[j].W += layer[j].DeltaW;  
    layer[j].bias += layer[j].Delta_bias;   
  }
}  
void GradientDescent::Zero_Delta_W(unsigned n_layers, LayerNetTrain layer[]) 
{
  int i,r,c;
  unsigned rig, col;
  for (i=0; i < n_layers; i++)  {
    matrix& m = layer[i].DeltaW;
    vect& v = layer[i].Delta_bias;
    rig  = m.dim1();
    col  = m.dim2();    
    for (r=0; r<rig; r++)  {
      v[r] = 0;
      for (c=0; c<col; c++)
        m(r,c) = 0;
    }
 }
}
void GradDescDecrEtaExp::Update_param (double err, unsigned iter)
{  
  if (eta > MIN_ETA)
     eta *= decr_factor;
}  
void GradDescDecrEtaLin::Update_param (double err, unsigned iter)
{  
  if (eta > MIN_ETA)
     eta -= decr_factor;
}  
MomentumDescent::MomentumDescent(unsigned n_output, unsigned n_input,
                  double x, double y)
{
  eta = x; 
  alpha = y;
  Delta_W_total[0] = new matrix(n_output, n_input); 
  delta_bias_total[0] = new vect(n_output); 
  Delta_W_total[1] = new matrix(); 
  delta_bias_total[1] = new vect(); 
  Delta_W_total[2] = new matrix(); 
  delta_bias_total[2] = new vect();   
}
MomentumDescent::MomentumDescent(unsigned n_output, unsigned n_hidden, unsigned n_input,
                  double x, double y)
{
  eta = x; 
  alpha = y;
  Delta_W_total[0] = new matrix(n_output, n_hidden); 
  delta_bias_total[0] = new vect(n_output); 
  Delta_W_total[1] = new matrix(n_hidden, n_input); 
  delta_bias_total[1] = new vect(n_hidden); 
  Delta_W_total[2] = new matrix(); 
  delta_bias_total[2] = new vect();   
}
MomentumDescent::MomentumDescent(unsigned n_output, unsigned n_hidden1, unsigned n_hidden2, unsigned n_input,
                  double x, double y)
{
  eta = x; 
  alpha = y;
  Delta_W_total[0] = new matrix(n_output, n_hidden1); 
  delta_bias_total[0] = new vect(n_output); 
  Delta_W_total[1] = new matrix(n_hidden1, n_hidden2); 
  delta_bias_total[1] = new vect(n_hidden1); 
  Delta_W_total[2] = new matrix(n_hidden2, n_input); 
  delta_bias_total[2] = new vect(n_hidden2);  
}                  
MomentumDescent::~MomentumDescent() 
{
  int j;
  for (j=0; j<MAXLAYERS; j++)  {
    delete Delta_W_total[j];
    delete delta_bias_total[j];
  }
}
void MomentumDescent::Update_weigths(unsigned n_layers, LayerNetTrain layer[] )
{
  int j;
  for (j=0; j<n_layers; j++)  {                                                              
    **(Delta_W_total+j) = layer[j].DeltaW + (**(Delta_W_total+j) * alpha);
    **(delta_bias_total+j) = layer[j].Delta_bias + (**(delta_bias_total+j) * alpha);
    layer[j].W += (**(Delta_W_total+j));
    layer[j].bias += (**(delta_bias_total+j));
  } 
} 
void MomentumDescent::Zero_Delta_W_total(unsigned n_layers) 
{
  int i,r,c;
  unsigned rig, col;
  for (i=0; i < n_layers; i++)  {
    matrix& m = **(Delta_W_total+i);
    vect& v = **(delta_bias_total+i);
    rig  = m.dim1();
    col  = m.dim2();    
    for (r=0; r<rig; r++)  {
      v[r] = 0.0;
      for (c=0; c<col; c++)
        m(r,c) = 0.0;
    }
 }
}
MomentumDescentDecrEtaExp::MomentumDescentDecrEtaExp(unsigned n_output, unsigned n_input,
                                                     double x, double y, double d_fact)
: MomentumDescent (n_output, n_input, x, y)
{
  decr_factor = d_fact;
}  
MomentumDescentDecrEtaExp::MomentumDescentDecrEtaExp(unsigned n_output, unsigned n_hidden,
                                                     unsigned n_input, double x, double y, double d_fact)
: MomentumDescent (n_output, n_hidden, n_input, x, y)
{
  decr_factor = d_fact;
}  
MomentumDescentDecrEtaExp::MomentumDescentDecrEtaExp(unsigned n_output, unsigned n_hidden1, 
                                   unsigned n_hidden2, unsigned n_input, double x, double y, double d_fact)
: MomentumDescent (n_output, n_hidden1, n_hidden2, n_input, x, y)
{
  decr_factor = d_fact;
}                
void MomentumDescentDecrEtaExp::Update_param (double err, unsigned iter)
{  
  if (eta > MIN_ETA)
     eta *= decr_factor;
}  
MomentumDescentDecrEtaLin::MomentumDescentDecrEtaLin(unsigned n_output, unsigned n_input,
                           double x, double y, double d_fact)
: MomentumDescent (n_output, n_input, x, y)
{decr_factor = d_fact;}  
MomentumDescentDecrEtaLin::MomentumDescentDecrEtaLin(unsigned n_output, unsigned n_hidden,
          unsigned n_input, double x, double y, double d_fact)
: MomentumDescent (n_output, n_hidden, n_input, x, y)
{decr_factor = d_fact;}  
MomentumDescentDecrEtaLin::MomentumDescentDecrEtaLin(unsigned n_output, unsigned n_hidden1, 
          unsigned n_hidden2, unsigned n_input, double x, double y, double d_fact)
: MomentumDescent (n_output, n_hidden1, n_hidden2, n_input, x, y)
{decr_factor = d_fact;}                
void MomentumDescentDecrEtaLin::Update_param (double err, unsigned iter)
{  
  if (eta > MIN_ETA)
     eta -= decr_factor;
}  
void BoldDriver::Update_param(double err, unsigned iter)
{
  double delta_err = err - err_prev;
  if (delta_err < 0)
    eta *= eta_incr;
  else if (delta_err > 0)
    eta *= eta_decr;
  err_prev = err; 
}  
BoldMomentum::BoldMomentum(unsigned n_output, unsigned n_input,
                  double x, double y, double incr, double decr)
: MomentumDescent(n_output,  n_input, x, y) 
{
  eta_incr = incr; 
  eta_decr = decr; 
  err_prev = 0.0;   
}
BoldMomentum::BoldMomentum(unsigned n_output, unsigned n_hidden, unsigned n_input,
                  double x, double y, double incr, double decr)
: MomentumDescent(n_output, n_hidden, n_input, x, y)
{
  eta_incr = incr; 
  eta_decr = decr; 
  err_prev = 0.0;
}
BoldMomentum::BoldMomentum(unsigned n_output, unsigned n_hidden1, unsigned n_hidden2, unsigned n_input,
                  double x, double y, double incr, double decr)
: MomentumDescent(n_output, n_hidden1, n_hidden2, n_input, x, y)
{
  eta_incr = incr; 
  eta_decr = decr; 
  err_prev = 0.0;  
}                  
void BoldMomentum::Update_param(double err, unsigned iter)
{
  double delta_err = err - err_prev;
  if (delta_err < 0)
    eta *= eta_incr;
  else if (delta_err > 0)  {
    eta *= eta_decr;
    Zero_Delta_W_total(MAXLAYERS);
  }
  err_prev = err; 
}  
