//  "resampled_pair_t_test.cc"
// December 2002
/**
  Application  implementing the resampled paired t test.
*/

#include<stdlib.h>
#include"utils.h"
#include"stattest.h"


static const int SIZE = 256;


/// file storing the misclassification rates of the first classifier
char err1[SIZE];

/// file storing the misclassification rates of the second classifier
char err2[SIZE];

void print_info_use(void);

////////////////////////////////////////////////////////
int main(int argc, char* argv[])
{
  
  if (argc != 3)
	  print_info_use();
  

  strcpy(err1, argv[1]);
  strcpy(err2, argv[2]);
	 
	ResPairT rpt(err1, err2);
	
  float res = rpt.test();
	
	cout << "Number of trials  : " << rpt.get_n() << endl;
  cout << "t statistic value : " << rpt.get_t() << endl;
  if (res == 0) 
    cout << "The null hypothesis cannot be rejected." <<endl;
  else
    cout << "The null hypothesis is rejected with degree of confidence equal to " << res << endl;		
  return 0;
}



void print_info_use(void)
{
  cerr << "
  resampled_pair_t_test. NEURObjects 2.0 application implementing the 
                         resampled paired t test.      
  Usage:    resampled_pair_t_test err1 err2
            err1  file storing the misclassification rates of the first classifier
            err2  file storing the misclassification rates of the second classifier
  " << endl;
  exit(1);
}


