// subsample.cc  8-9-2001 

#include<iostream.h>
#include<fstream.h>
#include<stdio.h>
#include<ctype.h>
#include<string.h>
#include"utils.h"
#include"tset.h"
#include"appl.h"

static int num_attr = NATTR;     
// name of the data set to be sampled
static char dataset[128]; 
// base name of the subsampled data sets 
static char basename_s[128]; 
// number of samples of subsampled sata sets
static unsigned num_samples = NSAMPLES;
// number of subsampled sata sets
static unsigned num_datasets = NDATASETS;
// separator char of the dataset
static char sepin = SEPIN;
// separator char of the subsampled data sets
static char sepout = SEPOUT;

static void print_info_use(void);
static int doarg(char* arg[], int i);

int main (int argc, char * argv[])
{
  int i;
	unsigned num_train;
	char suffix[8];
	char newdatafile[128];
	
	if (argc < 2)
	  print_info_use();
	
	strcpy(dataset,argv[1]);
	// set the default basename
	strcpy(basename_s,SUBBASENAME);
	for (i=2; i<argc; i+=2)
     if (doarg(argv, i))
        print_info_use();	
	
	num_train = wc (dataset);  
  TrainingSet trainset(num_attr, num_train,  dataset, sepin);
	
	// setting character separator
	trainset.set_sep(sepout);
	for (i=1; i<=num_datasets; i++) {
		sprintf(suffix,"%d",i);
		strcpy(newdatafile,basename_s);
		strcat(newdatafile,suffix);
	  trainset.Subsample_with_replacement (newdatafile, num_samples);
	}
	
  return 0;
}


static int doarg(char* arg[], int i)
{
  int j;
	if (!strcmp(arg[i], "-bn"))
    strcpy(basename_s, arg[i+1]);
  else if (!strcmp(arg[i], "-d")) {
    num_attr = atoi(arg[i+1]);
		if (num_attr < 1) error_exit("Number of attributes must be 1 or more");}
  else if (!strcmp(arg[i], "-ns")) {
    num_samples = atoi(arg[i+1]);
		if (num_samples < 1) error_exit("Number of samples must be 1 or more");}
	else if (!strcmp(arg[i], "-nd")) {
    num_datasets = atoi(arg[i+1]);
		if (num_datasets < 1) error_exit("Number of data sets be 1 or more");}
	else if (!strcmp(arg[i], "-sepin")) {
    sepin = arg[i+1][0];
		if (!isprint(sepin)) error_exit("Separator must be a printable character");}
	else if (!strcmp(arg[i], "-sepout")) {
    sepout = arg[i+1][0];
		if (!isprint(sepout)) error_exit("Separator must be a printable character");}  
  else 
    return 1;
  return 0;
} 


void print_info_use(void)
{
  cerr << "
  subsample. NEURObjects application to subsample data
  Usage: subsample dataset [options]
  dataset is the dataset to be subsampled.
  Options:
  -bn string         base name of the new resampled data file
  -d  unsigned        sample dimension
  -ns unsigned        number of samples per file 
  -nd unsigned        number of data sets
  -sepin char        separator of the dataset
  -sepout char       separator of the resampled data files
  " << endl;
  exit(1);
}
