// utils.h 


#ifndef UTILS_H
#define UTILS_H

#include<stdlib.h>
#include<math.h>
#include<iostream.h>
#include<stdio.h>
#include<string.h>
#include<fstream.h>
#include<time.h>
#include <sys/times.h>
#include "vect.h"
#include "matrix.h"


extern void error(char* s, char* s2 = "");
extern void error_exit(char* s, char* s2 = "");
extern int wc_word (char *file);
extern int wc_word (string& s);
extern int wc (char *file);
extern void load_string (ifstream& from, char *buf, char sep);

void extract(char from[], char to[], char c);
extern istream& eatwhite(istream& is);

extern float gasdev(long *idum);
extern float ran1(long *idum);

extern double Elapsed_sec(clock_t start, clock_t end);

enum stop_cond {STOP_NUM_ITERAZ, STOP_ERR_TOL};

void print_elapsed_time(time_t start, time_t end, ostream& f = cout);
void print_elapsed_cpu_time(clock_t start, clock_t end, ostream& f = cout);
void print_elapsed_time_from_start(ostream& f = cout);
void print_elapsed_time(struct tms *buf, ostream& f = cout);

double NormL1(const vect& v1, const vect& v2);

double NormL2(const vect& v1, const vect& v2);

double Hamming(const vect& v1, const vect& v2);


void print_conf_matrix(matrix& conf, ostream& f = cout);

void SumConf(matrix& sumconf, matrix& conf);


void CopyConf(matrix& conf_to, matrix& conf_from);

extern istream& toendofline(istream& is);

/**
  Deletes from the string file all the directories, returning in file only the file name.
*/
extern void delete_dir(char file[]);

#endif
